package com.engine.organization.entity.hrmresource.bo;

import com.engine.organization.entity.hrmresource.po.ResourceChartPO;
import com.engine.organization.entity.hrmresource.vo.ResourceChartVO;
import com.engine.organization.transmethod.HrmResourceTransMethod;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;

import java.util.ArrayList;
import java.util.List;

/**
 * @author:dxfeng
 * @createTime: 2023/07/06
 * @version: 1.0
 */
public class ResourceChartBO {

    public static List<ResourceChartVO> convertToVO(List<ResourceChartPO> resourceChartPOS) {
        List<ResourceChartVO> resourceChartVOS = new ArrayList<>();
        for (ResourceChartPO resourceChartPO : resourceChartPOS) {
            ResourceChartVO resourceChartVO = new ResourceChartVO();

            resourceChartVO.setId(resourceChartPO.getId());
            resourceChartVO.setWorkCode(resourceChartPO.getWorkCode());
            resourceChartVO.setLastName(resourceChartPO.getLastName());
            resourceChartVO.setSex("1".equals(resourceChartPO.getSex()) ? "女" : "男");
            resourceChartVO.setDepartmentName(HrmResourceTransMethod.getDepartmentName(Util.null2String(resourceChartPO.getDepartmentId())));
            resourceChartVO.setSubcompanyName(HrmResourceTransMethod.getCompanyName(Util.null2String(resourceChartPO.getSubcompanyid1())));
            resourceChartVO.setJobTitle(selectCustomName(resourceChartPO.getId()));
            resourceChartVO.setStatus(resourceChartPO.getStatus());
            resourceChartVO.setMobile(resourceChartPO.getMobile());
            resourceChartVOS.add(resourceChartVO);
        }
        return resourceChartVOS;
    }


    /**
     * 上海港湾二开 查询自定义职位名称 uf_zwxxjmb
     */
    private static String selectCustomName(long id){
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();
        String scopeid = bb.getPropValue("hrmOrganization", "scopeid");
        String fieldid = bb.getPropValue("hrmOrganization", "fieldid");
        String jobName = "";
        rs.executeQuery("select c.zwmc as jobname from hrmresource a \n" +
                "left join cus_fielddata b on a.id = b.id and b.scopeid = "+scopeid+"\n" +
                "left join uf_zwxxjmb c on b."+fieldid+" = c.id\n" +
                "where a.status < 4 and a.id = ?",id);
        if (rs.next()){
            jobName = rs.getString("jobname");
        }

        return jobName;
    }


}
