package com.engine.organization.entity.logview.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.organization.annotation.*;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

/**
 * @author:dxfeng
 * @createTime: 2022/07/05
 * @version: 1.0
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@OrganizationTable(pageId = "caef4d3e-fc3d-11ec-a203-00e04c680716",
        fields = "t.id, t.operator_name, t.create_time, t.operate_type, t.client_ip, t.operate_module_name,t.operate_desc,t.message,t.value,t.params_str",
        fromSql = "FROM hr_log t ",
        primarykey = "id",
        orderby = "create_time",
        tableType = WeaTableType.NONE
)
public class LogViewVO {

    @OrganizationTableColumn(labelId = 547159, text = "操作时间", width = "20%", column = "create_time", transmethod = "com.engine.organization.transmethod.LogViewTransMethod.getDateTimeFormat")
    private Date createTime;

    @OrganizationTableColumn(labelId = 547160, text = "操作者", width = "16%", column = "operator_name")
    private String operator;

    @OrganizationTableColumn(labelId = 547161, text = "操作类型", width = "16%", column = "operate_type", transmethod = "com.engine.organization.transmethod.LogViewTransMethod.getOperateType", multiLanguage = true)
    private String operateType;

    //@OrganizationTableColumn(labelId = 547162, text = "操作描述", width = "16%", column = "operate_desc")
    //private String operateDesc;

    @OrganizationTableColumn(labelId = 547163, text = "对象", width = "16%", column = "value")
    private String value;

    @OrganizationTableColumn(labelId = 547164, text = "所属模块", width = "16%", column = "operate_module_name", transmethod = "com.engine.organization.transmethod.LogViewTransMethod.getOperateModuleName", multiLanguage = true)
    private String operateModuleName;

    @OrganizationTableColumn(labelId = 547165, text = "修改详情", width = "16%", column = "message", transmethod = "com.engine.organization.transmethod.LogViewTransMethod.getOperateDetail", multiLanguage = true)
    private String showDetail;

    @OrganizationTableColumn(labelId = 547166, text = "操作IP", width = "16%", column = "client_ip")
    private String clientIp;

    @OrganizationTableColumn(labelId = 547413, text = "操作参数", width = "16%", column = "params_str", display = false)
    private String paramsStr;

}
