package com.engine.shgw.action;

import com.alibaba.fastjson.JSONObject;
import com.engine.shgw.Util.ActionUtils;
import com.time.util.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.Map;

/**
 * 员工调动流程
 * 流程中 调入部门冻结数+1
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/5/14
 */

public class EmployeeTransferUpdateOrgStaffAction implements Action {

    //调动后部门 数据库字段名
    private String newbmKey;


    @Override
    public String execute(RequestInfo requestInfo) {
        BaseBean bb = new BaseBean();
        try {
            String tableName = requestInfo.getRequestManager().getBillTableName();
            String requestid = requestInfo.getRequestid();
            String createdate = getWfRequestDate(requestid);
            //获取主表数据
            Map mainInfo = ActionUtils.getMainInfo(requestInfo);
            bb.writeLog("-EmployeeTransferUpdateOrgStaffAction-主表数据是：" + JSONObject.toJSONString(mainInfo));


            //调动前部门 数据库字段名
//            oldbmKey = Util.null2String(oldbmKey);
//            //调动前公司 数据库字段名
//            oldgsKey = Util.null2String(oldgsKey);

            //调动后部门 数据库字段名
            newbmKey = Util.null2String(newbmKey);
            //调动后公司 数据库字段名
//            newgsKey = Util.null2String(newgsKey);

            if ("".equals(newbmKey)) {
                requestInfo.getRequestManager().setMessagecontent("必传字段为空,请联系管理员！");
                return Action.FAILURE_AND_CONTINUE;
            }

            //调动后部门
            String xrzbm = Util.null2String(mainInfo.get(newbmKey));


            if (!"".equals(xrzbm)) {
                boolean flag = updateOrgStaffByDept(xrzbm,createdate);
                if(flag){
                    requestInfo.getRequestManager().setMessagecontent("调动后部门编制超编，提交失败！");
                    return Action.FAILURE_AND_CONTINUE;
                }
            }


        } catch (Exception e) {
            requestInfo.getRequestManager().setMessagecontent("接口异常:" + e.getMessage());
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }

    private void updateOrgStaffBySubCom(String subcomid) {
        RecordSet rs = new RecordSet();
        String sql = "select a.id,a.ec_company,a.ec_department,a.job_id,a.staff_num,a.permanent_num,a.lack_status from jcl_org_staff a left join jcl_org_staffplan b on a.plan_id = b.id  where a.delete_type = 0 and b.control_dimension = 1 and b.forbidden_tag = 0 and a.ec_company = '" + subcomid + "'";
        rs.execute(sql);
        while (rs.next()) {
            String id = Util.null2String(rs.getString("id"));
            int staff_num = Util.getIntValue(rs.getString("staff_num"));
            int permanent_num = Util.getIntValue(rs.getString("permanent_num"));

            updateOrgStaff(id);
        }
    }

    /**
     * 判断该部门编制是否是强控，强控时 是否会超编
     *
     * @param deptid
     */
    private boolean updateOrgStaffByDept(String deptid,String createdate) {
        boolean flag = false;
        RecordSet rs = new RecordSet();
        String sql = "select a.id,a.ec_company,a.ec_department,a.job_id,a.staff_num,a.permanent_num,a.freeze_num,a.lack_status,a.control_policy from jcl_org_staff a left join jcl_org_staffplan b on a.plan_id = b.id  where a.delete_type = 0 and b.control_dimension = 2 and b.forbidden_tag = 0 and a.ec_department = '" + deptid + "' and b.time_end >= '"+createdate+"' and b.time_start <= '"+createdate+"'";
        rs.execute(sql);
        while (rs.next()) {
            String id = Util.null2String(rs.getString("id"));
            int staff_num = Util.getIntValue(rs.getString("staff_num"));
            int permanent_num = Util.getIntValue(rs.getString("permanent_num"));
            int freeze_num = Util.getIntValue(rs.getString("freeze_num"));
            //2强控，1弱控，3不控
            int control_policy = Util.getIntValue(rs.getString("control_policy"));
            //强控 且 超编
            if (control_policy == 2 && staff_num < (permanent_num + freeze_num + 1)) {
                flag = true;
            } else {
                updateOrgStaff(id);
            }
        }
        return flag;
    }


    /**
     * 更新冻结数+1
     *
     * @param id
     */
    private void updateOrgStaff(String id) {
        RecordSet rs = new RecordSet();
        String sql = "update jcl_org_staff set freeze_num = freeze_num+1 where id = ?";
        rs.executeUpdate(sql, id);
    }

    private String getWfRequestDate(String requestid){
        String date = "";
        if("".equals(requestid)){
            date = DateUtil.getCurrentTime("yyyy-MM-dd");
            return date;
        }
        RecordSet rs = new RecordSet();
        String sql = "select createdate from workflow_requestbase where requestid = '"+requestid+"'";
        rs.execute(sql);
        while (rs.next()){
            date = Util.null2String(rs.getString("createdate"));
        }
        return date;
    }
}
