package com.engine.shgw.action;

import com.alibaba.fastjson.JSONObject;
import com.engine.shgw.Util.ActionUtils;
import com.time.util.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.Map;

/**
 * 员工调动流程(归档)
 * <p>
 * 流程结束 调入部门在编数+1 冻结数-1 调出部门在编数-1
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/5/14
 */

public class EmployeeTransferUpdateOrgStaffGdAction implements Action {
    //调动前部门 数据库字段名
    private String oldbmKey;


    //调动后部门 数据库字段名
    private String newbmKey;


    @Override
    public String execute(RequestInfo requestInfo) {
        BaseBean bb = new BaseBean();
        try {
            String tableName = requestInfo.getRequestManager().getBillTableName();
            String requestid = requestInfo.getRequestid();
            String createdate = getWfRequestDate(requestid);
            //获取主表数据
            Map mainInfo = ActionUtils.getMainInfo(requestInfo);
            bb.writeLog("-EmployeeTransferUpdateOrgStaffGdAction-主表数据是：" + JSONObject.toJSONString(mainInfo));


            //调动前部门 数据库字段名
            oldbmKey = Util.null2String(oldbmKey);


            //调动后部门 数据库字段名
            newbmKey = Util.null2String(newbmKey);


            if ("".equals(oldbmKey) || "".equals(newbmKey)) {
                requestInfo.getRequestManager().setMessagecontent("必传字段为空,请联系管理员！");
                return Action.FAILURE_AND_CONTINUE;
            }

            //调动前公司
//            String yrzgs = Util.null2String(mainInfo.get(oldgsKey));
            //调动前部门
            String yrzbm = Util.null2String(mainInfo.get(oldbmKey));
            //调动后公司
//            String xrzgs = Util.null2String(mainInfo.get(newgsKey));
            //调动后部门
            String xrzbm = Util.null2String(mainInfo.get(newbmKey));


//            if (!"".equals(xrzgs)) {
//                updateOrgStaffBySubCom(xrzgs);
//            }

            if (!"".equals(xrzbm)) {
                updateOrgStaffByDept(xrzbm,createdate);
            }

//            if (!"".equals(yrzgs)) {
//                updateOrgStaffBySubComOld(xrzgs);
//            }

            if (!"".equals(yrzbm)) {
                updateOrgStaffByDeptOld(yrzbm,createdate);
            }


        } catch (Exception e) {
            requestInfo.getRequestManager().setMessagecontent("接口异常:" + e.getMessage());
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }

    private void updateOrgStaffBySubCom(String subcomid) {
        RecordSet rs = new RecordSet();
        String sql = "select a.id,a.ec_company,a.ec_department,a.job_id,a.staff_num,a.permanent_num,a.lack_status from jcl_org_staff a left join jcl_org_staffplan b on a.plan_id = b.id  where a.delete_type = 0 and b.control_dimension = 1 and b.forbidden_tag = 0 and a.ec_company = '" + subcomid + "'";
        rs.execute(sql);
        while (rs.next()) {
            String id = Util.null2String(rs.getString("id"));
            int staff_num = Util.getIntValue(rs.getString("staff_num"));
            int permanent_num = Util.getIntValue(rs.getString("permanent_num"));
            updateOrgStaff(id, staff_num, permanent_num);
        }
    }

    private void updateOrgStaffByDept(String deptid,String createdate) {
        RecordSet rs = new RecordSet();
        String sql = "select a.id,a.ec_company,a.ec_department,a.job_id,a.staff_num,a.permanent_num,a.lack_status from jcl_org_staff a left join jcl_org_staffplan b on a.plan_id = b.id  where a.delete_type = 0 and b.control_dimension = 2 and b.forbidden_tag = 0 and a.ec_department = '" + deptid + "' and b.time_end >= '"+createdate+"' and b.time_start <= '"+createdate+"'";
        rs.execute(sql);
        while (rs.next()) {
            String id = Util.null2String(rs.getString("id"));
            int staff_num = Util.getIntValue(rs.getString("staff_num"));
            int permanent_num = Util.getIntValue(rs.getString("permanent_num"));
            updateOrgStaff(id, staff_num, permanent_num);
        }
    }

    private void updateOrgStaffBySubComOld(String subcomid) {
        RecordSet rs = new RecordSet();
        String sql = "select a.id,a.ec_company,a.ec_department,a.job_id,a.staff_num,a.permanent_num,a.lack_status from jcl_org_staff a left join jcl_org_staffplan b on a.plan_id = b.id  where a.delete_type = 0 and b.control_dimension = 1 and b.forbidden_tag = 0 and a.ec_company = '" + subcomid + "'";
        rs.execute(sql);
        while (rs.next()) {
            String id = Util.null2String(rs.getString("id"));
            int staff_num = Util.getIntValue(rs.getString("staff_num"));
            int permanent_num = Util.getIntValue(rs.getString("permanent_num"));
            updateOrgStaffOld(id, staff_num, permanent_num);
        }
    }

    private void updateOrgStaffByDeptOld(String deptid,String createdate) {
        RecordSet rs = new RecordSet();
        String sql = "select a.id,a.ec_company,a.ec_department,a.job_id,a.staff_num,a.permanent_num,a.lack_status from jcl_org_staff a left join jcl_org_staffplan b on a.plan_id = b.id  where a.delete_type = 0 and b.control_dimension = 2 and b.forbidden_tag = 0 and a.ec_department = '" + deptid + "' and b.time_end >= '"+createdate+"' and b.time_start <= '"+createdate+"'";
        rs.execute(sql);
        while (rs.next()) {
            String id = Util.null2String(rs.getString("id"));
            int staff_num = Util.getIntValue(rs.getString("staff_num"));
            int permanent_num = Util.getIntValue(rs.getString("permanent_num"));
            updateOrgStaffOld(id, staff_num, permanent_num);
        }
    }


    /**
     * 更新冻结数-1 在编数+1
     *
     * @param id
     */
    private void updateOrgStaff(String id, int staff_num, int permanent_num) {
        RecordSet rs = new RecordSet();

        permanent_num = permanent_num + 1;

        //lack_status 缺编状态 1缺编，2满编，3超编
        int lack_status = 1;
        if (permanent_num < staff_num) {
            lack_status = 1;
        } else if (permanent_num == staff_num) {
            lack_status = 2;
        } else if (permanent_num > staff_num) {
            lack_status = 3;
        }

        String sql = "update jcl_org_staff set freeze_num = freeze_num-1,permanent_num = ?,lack_status = ? where id = ?";
        rs.executeUpdate(sql, permanent_num, lack_status, id);
    }

    /**
     * 更新在编数-1
     *
     * @param id
     */
    private void updateOrgStaffOld(String id, int staff_num, int permanent_num) {
        RecordSet rs = new RecordSet();

        permanent_num = permanent_num - 1;

        //lack_status 缺编状态 1缺编，2满编，3超编
        int lack_status = 1;
        if (permanent_num < staff_num) {
            lack_status = 1;
        } else if (permanent_num == staff_num) {
            lack_status = 2;
        } else if (permanent_num > staff_num) {
            lack_status = 3;
        }

        String sql = "update jcl_org_staff set permanent_num = ?,lack_status = ? where id = ?";
        rs.executeUpdate(sql, permanent_num, lack_status, id);
    }

    private String getWfRequestDate(String requestid){
        String date = "";
        if("".equals(requestid)){
            date = DateUtil.getCurrentTime("yyyy-MM-dd");
            return date;
        }
        RecordSet rs = new RecordSet();
        String sql = "select createdate from workflow_requestbase where requestid = '"+requestid+"'";
        rs.execute(sql);
        while (rs.next()){
            date = Util.null2String(rs.getString("createdate"));
        }
        return date;
    }
}
