package com.engine.shgw.action;

import com.alibaba.fastjson.JSONObject;
import com.engine.shgw.Util.ActionUtils;
import com.time.util.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.Map;

/**
 * 入职流程
 * 部门编制 冻结数+1
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/5/14
 */

public class EmploymentUpdateOrgStaffAction implements Action {
    //部门 数据库字段名
    private String bmKey;

    @Override
    public String execute(RequestInfo requestInfo) {
        BaseBean bb = new BaseBean();
        try {
            String tableName = requestInfo.getRequestManager().getBillTableName();
            String requestid = requestInfo.getRequestid();
            String createdate = getWfRequestDate(requestid);
            //获取主表数据
            Map mainInfo = ActionUtils.getMainInfo(requestInfo);
            bb.writeLog("-EmploymentUpdateOrgStaffAction-主表数据是：" + JSONObject.toJSONString(mainInfo));

            //部门 数据库字段名
            bmKey = Util.null2String(bmKey);


            if("".equals(bmKey)){
                requestInfo.getRequestManager().setMessagecontent("必传字段为空,请联系管理员！");
                return Action.FAILURE_AND_CONTINUE;
            }

            //分部
//            String fb = Util.null2String(mainInfo.get(gsKey));
            //部门
            String bm = Util.null2String(mainInfo.get(bmKey));

//            if (!"".equals(fb)) {
//                updateOrgStaffBySubCom(fb);
//            }

            if (!"".equals(bm)) {
                boolean flag = updateOrgStaffByDept(bm,createdate);
                if(flag){
                    requestInfo.getRequestManager().setMessagecontent("入职部门编制超编，提交失败！");
                    return Action.FAILURE_AND_CONTINUE;
                }
            }


        } catch (Exception e) {
            requestInfo.getRequestManager().setMessagecontent("接口异常:" + e.getMessage());
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }

    private void updateOrgStaffBySubCom(String subcomid) {
        RecordSet rs = new RecordSet();
        String sql = "select a.id,a.ec_company,a.ec_department,a.job_id,a.staff_num,a.permanent_num,a.lack_status from jcl_org_staff a left join jcl_org_staffplan b on a.plan_id = b.id  where a.delete_type = 0 and b.control_dimension = 1 and b.forbidden_tag = 0 and a.ec_company = '" + subcomid + "'";
        rs.execute(sql);
        while (rs.next()) {
            String id = Util.null2String(rs.getString("id"));

            updateOrgStaff(id);
        }
    }

    private boolean updateOrgStaffByDept(String deptid,String createdate) {
        RecordSet rs = new RecordSet();
        boolean flag = false;
        String sql = "select a.id,a.ec_company,a.ec_department,a.job_id,a.staff_num,a.permanent_num,a.freeze_num,a.control_policy,a.lack_status from jcl_org_staff a left join jcl_org_staffplan b on a.plan_id = b.id  where a.delete_type = 0 and b.control_dimension = 2 and b.forbidden_tag = 0 and a.ec_department = '" + deptid + "' and b.time_end >= '"+createdate+"' and b.time_start <= '"+createdate+"'";
        rs.execute(sql);
        while (rs.next()) {
            String id = Util.null2String(rs.getString("id"));

            int staff_num = Util.getIntValue(rs.getString("staff_num"));
            int permanent_num = Util.getIntValue(rs.getString("permanent_num"));
            int freeze_num = Util.getIntValue(rs.getString("freeze_num"));

            //2强控，1弱控，3不控
            int control_policy = Util.getIntValue(rs.getString("control_policy"));
            //强控 且 超编
            if (control_policy == 2 && staff_num < (permanent_num + freeze_num + 1)) {
                flag = true;
            } else {
                updateOrgStaff(id);
            }

        }
        return flag;
    }


    /**
     * 更新冻结数+1
     * @param id
     */
    private void updateOrgStaff(String id) {
        RecordSet rs = new RecordSet();
        String sql = "update jcl_org_staff set freeze_num = freeze_num+1 where id = ?";
        rs.executeUpdate(sql, id);
    }

    private String getWfRequestDate(String requestid){
        String date = "";
        if("".equals(requestid)){
            date = DateUtil.getCurrentTime("yyyy-MM-dd");
            return date;
        }
        RecordSet rs = new RecordSet();
        String sql = "select createdate from workflow_requestbase where requestid = '"+requestid+"'";
        rs.execute(sql);
        while (rs.next()){
            date = Util.null2String(rs.getString("createdate"));
        }
        return date;
    }
}
